close all;
clc;
clear all;

im=imread('Coastline.bmp');
figure(); imshow(im);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

im3=im;
im3(308:512,:)=0;
figure(); imshow(im3);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

BW = im2bw(im3,120/255);
figure();
imshow(BW);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

L = bwlabeln(BW);
S = regionprops(L, 'Area');
BW_3 = ismember(L, find([S.Area] >20));
figure();
imshow(BW_3)
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

%%%%%%%********************ͼϳ***************%%%%%%%%%%%%
BW_3=im2uint8(BW_3);

A(:,:,1)=im+BW_3*255;
A(:,:,2)=im-BW_3*255;
A(:,:,3)=im-BW_3*255;
figure();
imshow(A);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

A(:,:,1)=flipud(A(:,:,1));
A(:,:,2)=flipud(A(:,:,2));
A(:,:,3)=flipud(A(:,:,3));

A1=double(A(:,:,1));
A2=double(A(:,:,2));
A3=double(A(:,:,3)); 
[m n]=size(A1);
[t r]=meshgrid(linspace(-pi,pi,n),1:m); 
M=2*m;
N=2*n;
[NN MM]=meshgrid((1:N)-n-0.5,(1:M)-m-0.5);
T=atan2(NN,MM);
R=sqrt(MM.^2+NN.^2);                
 
B1=interp2(t,r,A1,T,R,'linear',0);
B2=interp2(t,r,A2,T,R,'linear',0);
B3=interp2(t,r,A3,T,R,'linear',0);
B=uint8(cat(3,B1,B2,B3));      
B = B(:,(n-m):(n+m),:);
B(:,:,1)=fliplr(B(:,:,1));
B(:,:,2)=fliplr(B(:,:,2));
B(:,:,3)=fliplr(B(:,:,3));
B = imrotate(B, -90);
figure();
imshow(B);
xlabel('Detection distance (nautical mile)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'-0.75','0','0.75'});
set(gca,'YTick',0:512:1024);
set(gca,'YTickLabel',{'0.75','0','-0.75'});
set(gcf,'color','w')
axis on;

