clc;close all;clear all;

I=imread('result.bmp');

figure;
imshow(I);

I_medfilt=flipud(I);

A1=double(I_medfilt(:,:,1));
[m n]=size(A1);
[t r]=meshgrid(linspace(-pi,pi,n),1:m); %ԭͼ
 
M=2*m;
N=2*n;
[NN MM]=meshgrid((1:N)-n-0.5,(1:M)-m-0.5);
T=atan2(NN,MM);
R=sqrt(MM.^2+NN.^2);                  
 
B1=interp2(t,r,A1,T,R,'linear',0);
B=uint8(cat(1,B1));        
 
B = B(:,(n-m):(n+m));
B=fliplr(B);
B1 = imrotate(B,-90);
B1 = B1*255;
figure;
imshow(B1);
title('ϵ');
xlabel('Detection distance (nautical mile)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'-0.75','0','0.75'});
set(gca,'YTick',0:512:1024);
set(gca,'YTickLabel',{'0.75','0','-0.75'});
set(gcf,'color','w')
axis on;

B2 = imrotate(B1,-19.5);
figure;
imshow(B2);
xlabel('Detection distance (nautical mile)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:654:1309);
set(gca,'XTickLabel',{'-0.75','0','0.75'});
set(gca,'YTick',0:654:1309);
set(gca,'YTickLabel',{'0.75','0','-0.75'});
set(gcf,'color','w')
axis on;

contour = bwperim(B2);                    
figure; 
imshow(contour);  
title('');
xlabel('Detection distance (nautical mile)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:654:1309);
set(gca,'XTickLabel',{'-0.75','0','0.75'});
set(gca,'YTick',0:654:1309);
set(gca,'YTickLabel',{'0.75','0','-0.75'});
set(gcf,'color','w')
axis on;

figure;
[C,handle] = imcontour(contour);
set(gcf,'color','w');
axis off;

[R,L] =bwboundaries(B2);
fid = fopen('boundary.txt','wt');
for k = 1:length(R)
    for m=1:length(R{k,1})
        x = R{k,1}(m,1);
        y = R{k,1}(m,2);
        fprintf(fid,'%d,%d,',x,y);
    end
    fprintf(fid,'\n');
end
fclose(fid);


