﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;
using System.IO;
using System.Diagnostics;
using Microsoft.Win32;
using ESRI.ArcGIS.Controls;
using ESRI.ArcGIS.Geometry;
using ESRI.ArcGIS.SystemUI;
using ESRI.ArcGIS.Carto;
using ESRI.ArcGIS.Display;
using ESRI.ArcGIS.esriSystem;
using ESRI.ArcGIS.Analyst3D;
using ESRI.ArcGIS.Output;
using ESRI.ArcGIS.Geodatabase;
using System.IO;

namespace RadarAndENC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            ESRI.ArcGIS.RuntimeManager.Bind(ESRI.ArcGIS.ProductCode.EngineOrDesktop);
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            axTOCControl1.SetBuddyControl(axMapControl1);
            axMapControl1.LoadMxFile(Application.StartupPath + "\\Map\\DalianPort.mxd");
        }

        private void Btn_ZoomIn_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {
            ControlsMapZoomInTool Zoomin = new ControlsMapZoomInTool();
            Zoomin.OnCreate(axMapControl1.Object);
            axMapControl1.CurrentTool = (ESRI.ArcGIS.SystemUI.ITool)Zoomin;
        }

        private void Btn_ZoomOut_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {
            ControlsMapZoomOutTool Zoomout = new ControlsMapZoomOutTool();
            Zoomout.OnCreate(axMapControl1.Object);
            axMapControl1.CurrentTool = (ESRI.ArcGIS.SystemUI.ITool)Zoomout;
        }

        private void Btn_Pan_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {
            ControlsMapPanTool pan = new ControlsMapPanTool();
            pan.OnCreate(axMapControl1.Object);
            axMapControl1.CurrentTool = (ESRI.ArcGIS.SystemUI.ITool)pan;
        }

        private void Btn_Test_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {

            string strTxt = "shipboundary.txt";   //Result of DataFusionCoordinates
            
            if (File.Exists(strTxt))
            {
                string strPos1 = ReadTxt(strTxt);
                string[] strPos2 = strPos1.Split('\n');
                foreach (string strPos in strPos2)
                {
                    if (strPos != null && strPos != "")
                    {
                        string[] array = strPos.Split(',');
                        double[,] OilPos = new double[(array.Length - 1) / 2, 2];
                        for (int i = 0; i < (array.Length - 1) / 2; i++)
                        {
                            OilPos[i, 0] = Convert.ToDouble(array[i * 2 + 1]) ;
                            OilPos[i, 1] = 1024 - Convert.ToDouble(array[i * 2]);
                        }
                        ESRI.ArcGIS.Geometry.IPoint PntCen = new ESRI.ArcGIS.Geometry.PointClass();  //Position of the ship
                        PntCen.X = 121.8760 ;
                        PntCen.Y = 38.9225;
                        
                        ESRI.ArcGIS.Geometry.ISpatialReferenceFactory srFactory = new ESRI.ArcGIS.Geometry.SpatialReferenceEnvironmentClass();
                        ESRI.ArcGIS.Geometry.ISpatialReference sr1 = srFactory.CreateGeographicCoordinateSystem((int)ESRI.ArcGIS.Geometry.esriSRGeoCSType.esriSRGeoCS_WGS1984);
                        PntCen.SpatialReference = sr1;
                        ESRI.ArcGIS.Geometry.ISpatialReference sr2 = srFactory.CreateProjectedCoordinateSystem((int)ESRI.ArcGIS.Geometry.esriSRProjCSType.esriSRProjCS_Beijing1954GK_21N);
                        PntCen.Project(sr2);

                        ESRI.ArcGIS.Geometry.IPolygon OilPg = new ESRI.ArcGIS.Geometry.PolygonClass();
                        ESRI.ArcGIS.Geometry.IPointCollection pntCol = OilPg as ESRI.ArcGIS.Geometry.IPointCollection;

                        for (int i = 0; i < OilPos.GetLength(0); i++)
                        {
                            ESRI.ArcGIS.Geometry.IPoint pPoint = new ESRI.ArcGIS.Geometry.PointClass();
                            double PixLength=(0.75*1852)/512;
                            OilPos[i, 0] = PntCen.X + (OilPos[i, 0] -512)* PixLength;
                            OilPos[i, 1] = PntCen.Y + (OilPos[i, 1] - 512)* PixLength;  
                            pPoint.X = OilPos[i, 0];
                            pPoint.Y = OilPos[i, 1];
                            pntCol.AddPoint(pPoint);
                        }

                        OilPg.SpatialReference = sr2;
                        OilPg.Project(sr1);

                        ESRI.ArcGIS.Carto.IElement pElement;
                        ESRI.ArcGIS.Carto.IFillShapeElement p1 = new ESRI.ArcGIS.Carto.PolygonElementClass();

                        ESRI.ArcGIS.Display.ISimpleFillSymbol sym = new ESRI.ArcGIS.Display.SimpleFillSymbolClass();
                        ESRI.ArcGIS.Display.RgbColor iRgbColor;
                        iRgbColor = new ESRI.ArcGIS.Display.RgbColor();
                        iRgbColor.Red = 255;
                        iRgbColor.Blue = 0;
                        iRgbColor.Green = 0;
                        sym.Color = iRgbColor;
                        p1.Symbol = sym;
                        pElement = p1 as ESRI.ArcGIS.Carto.IElement;
                        pElement.Geometry = OilPg as ESRI.ArcGIS.Geometry.IGeometry;
                        this.axMapControl1.ActiveView.GraphicsContainer.AddElement(pElement, 0);
                        this.axMapControl1.ActiveView.Refresh();

                    }
                }
            }
        }

        string ReadTxt(string datName)
        {
            System.IO.FileStream fs1 = new System.IO.FileStream(datName, FileMode.Open);
            StreamReader m_S = new StreamReader(fs1, System.Text.Encoding.GetEncoding("GB2312"));

            string strline = m_S.ReadToEnd();
            m_S.Close();
            fs1.Close();
            return strline;
        }

        private void axMapControl1_OnMouseMove(object sender, IMapControlEvents2_OnMouseMoveEvent e)
        {
            Lbl_XY.Caption = "Longitude:" + e.mapX.ToString("#0.0000") + ",Latitude:" + e.mapY.ToString("#0.0000") + "    地图比例尺:1:" + axMapControl1.MapScale.ToString("#0");
        }

        private void Btn_Clear_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
        {
            this.axMapControl1.ActiveView.GraphicsContainer.DeleteAllElements();
            this.axMapControl1.ActiveView.Refresh();
        }
    }
}
