clear all;
close all;
clc;

[filename,pathname,flag] = uigetfile('*.bmp','뵼ͼļ');

imgorgine = imread([pathname,filename]);
figure(1);
imshow(imgorgine);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

img=imgorgine;
for i= 1:170         
    img(i,:)=0;
end

Nrow = 20;
Ncol = 80;
Iout3left = img(:,Ncol:-1:1);
Iout3right = img(:,end:-1:end-Ncol+1);
Iout4 = [Iout3left,img,Iout3right];
Iout3up = Iout4(Nrow:-1:1,:);
Iout3down = Iout4(end:-1:end-Nrow+1,:);
Iout4 = [Iout3up;Iout4;Iout3down];
I_medfilt= conv2(double(Iout4),double(ones(Nrow*2+1,Ncol*2+1)/((Nrow*2+1)*(Ncol*2+1))));
I_medfilt = I_medfilt(Nrow*2+1:end-Nrow*2,Ncol*2+1:end-Ncol*2);
figure(2);
imagesc(I_medfilt);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

BW_6 = im2bw(I_medfilt/255,60/255);    
figure(3);
imshow(BW_6);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

BW_6=uint8(BW_6);
ImgEffctive=immultiply(BW_6,img);
figure(4);
imshow(ImgEffctive);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

[length,height]=size(ImgEffctive);
BW=zeros(length,height);

Partition=32;
for i=1:(length/Partition)
    for j=1:(height/Partition)
        imwindow=ImgEffctive(((i-1)*Partition+1):(i*Partition),((j-1)*Partition+1):(j*Partition));
        imcmp=im2double(imwindow);
        level=mean(imcmp(:))*(1+0.25*((std2(imcmp)*std2(imcmp)/(0.5*0.5)-1)));   
        BWwindow=im2bw(imwindow,level);
        [len,hei]=size(BWwindow);
        for k=1:len
            for w=1:hei
                if BWwindow(k,w)==1
                    BW(((i-1)*Partition+k),((j-1)*Partition+w))=1;
                end
            end
        end
    end
end
BW=1-BW;
BW=uint8(BW)*255;
BW=immultiply(BW_6,BW);
figure(5);imshow(BW);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

result = bwareaopen(BW, 50); 
figure(6);imshow(result);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

figure();imshow(result);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;
imwrite(result,'2-20100721-232027ֵ.bmp');

result=uint8(result)*255;
A(:,:,1)=imgorgine+result;
A(:,:,2)=imgorgine-result;
A(:,:,3)=imgorgine-result;

figure();
imshow(A);
xlabel('Azimuth angle (degree)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:1024:2046);
set(gca,'XTickLabel',{'0','180','360'});
set(gca,'YTick',0:256:512);
set(gca,'YTickLabel',{'0.75','0.375','0'});
set(gcf,'color','w')
axis on;

A(:,:,1)=flipud(A(:,:,1));
A(:,:,2)=flipud(A(:,:,2));
A(:,:,3)=flipud(A(:,:,3));

A1=double(A(:,:,1));
A2=double(A(:,:,2));
A3=double(A(:,:,3));  
[m n]=size(A1);
[t r]=meshgrid(linspace(-pi,pi,n),1:m);
M=2*m;
N=2*n;
[NN MM]=meshgrid((1:N)-n-0.5,(1:M)-m-0.5);
T=atan2(NN,MM);
R=sqrt(MM.^2+NN.^2);                
B1=interp2(t,r,A1,T,R,'linear',0);
B2=interp2(t,r,A2,T,R,'linear',0);
B3=interp2(t,r,A3,T,R,'linear',0); 
B=uint8(cat(3,B1,B2,B3));        
B = B(:,(n-m):(n+m),:);
B(:,:,1)=fliplr(B(:,:,1));
B(:,:,2)=fliplr(B(:,:,2));
B(:,:,3)=fliplr(B(:,:,3));
figure();
imshow(B);
xlabel('Detection distance (nautical mile)');ylabel('Detection distance (nautical mile)');
set(gca,'XTick',0:512:1024);
set(gca,'XTickLabel',{'-0.75','0','0.75'});
set(gca,'YTick',0:512:1024);
set(gca,'YTickLabel',{'0.75','0','-0.75'});
set(gcf,'color','w')
axis on;